;length of horizontal scan
SCANLENGTH=32;16

ENEMY_COLOR=15;5;9;7
ENEMY_CLRSPAWN=4
ENEMY_CLRDEAD=8
ENEMY_CLRANGRY=13


;enemies states
ENEMY_IDLE=0
ENEMY_LEFT=1
ENEMY_RIGHT=2
ENEMY_DOWN=3
ENEMY_UP=4
ENEMY_FALL=5
;ENEMY_DEAD=6

MODE_PATROL_X=0
MODE_LADDER=1
;MODE_ATTACK=2
MODE_ANGRY=2
MODE_SPAWN=3

 DEFINE DEADENDTTL	10	; Number of bump-turns an enemy does before
				; deciding to suicide when trapped in a hole.
				; holes
 DEFINE SPR_ENEMY_BMPBASE	24
 DEFINE ENEMY_Y_LIMBO		200
 DEFINE ENEMY_Y_DISABLE		209


;===========================================================================
; Structures

 STRUCT OBJENEMY
; Common fields between the hero and the enemies
; Note: If you reorder or delete fields here, remember to also adjust OBJHERO
; and baseEnemies
xPos		db	0
yPos		db	ENEMY_Y_DISABLE
moveCounter	db	32
state		db	0		; Up/down/left/right
mode		db	MODE_PATROL_X
faceDir		db	FACE_RIGHT
prevMode	db	MODE_PATROL_X
rndSeedCounter	db	24
deadEndTtl	db	DEADENDTTL	; Number of times he had to switch direction 
sprAnimDelay	db	0
deathTimer	db	4	; Controls the dead state
; Specific fields for the enemies
startX		db	0	; Will be filled by the map parser
startY		db	0	; Will be filled by the map parser
sprFrame	db	SPR_ENEMY_BMPBASE*4
animCounter	db	0
 ENDS

;===========================================================================
; ROM data
baseEnemies:    
N=0
	dup MAXENEMIES
 OBJENEMY ,,(32+N*2)mod 256,,,,,(N*33)mod 256,(24+N*2)mod 256,,(4+N*16)mod 256
N=N+1
	edup

;===========================================================================
; Routines

resetEnemies:
    ;save current randoms
    ld hl,baseEnemies : ld de,enemiesList : ld bc,MAXENEMIES*OBJENEMY : ldir
	ld	iy,baseEnemies
	ld	ix,enemiesList
	ld	b,MAXENEMIES
20:	push	bc
	call	initRndGen		; Set a new random seed
	ld	de,OBJENEMY
	add	ix,de
	add	iy,de
	pop	bc
	djnz	20B
    ret

initRndGen:		; Input: ix=Pointer to enemy RAM table
			;        iy=Pointer to enemy ROM defaults
	call	xrnd16
	ld	a,h
	add	l
	add	(iy+OBJENEMY.rndSeedCounter) 	; Add the base counter
	ld	(ix+OBJENEMY.rndSeedCounter),a		; Set the base random counter
	ret

;====================BRIDGE UNDER BLOCK
chkBridge:
	ld	a,(gameState)
	cp	GS_BRIDGE	; A bridge is already being extended?
;	ld	a,8
	ret	z		; Yes, skip

	ld	a,(hl)
	cp	TILE_LEFT
	jr	z,9f
	cp	TILE_RIGHT
	ret	nz
	; Start bridge to the right
	inc	hl
	ld	a,(hl)
	cp	TILE_BRIDGE	; Return the other side already
	ret	z		; built this bridge
	dec	hl
	ld	(hl),TILE_ANTIRIGHT	;disable this arrow
	ld	a,FACE_RIGHT
	jr	5f
9:	; Start bridge to the left
	dec	hl
	ld	a,(hl)
	cp	TILE_BRIDGE	; Return the other side already
	ret	z		; built this bridge
	inc	hl
	ld	(hl),TILE_ANTILEFT	;disable this arrow
	ld	a,FACE_LEFT
5:	ld	(ttt2),a
;	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	de,(ix+OBJENEMY.xPos)	;coords to de 
	call	getTileCoords
	inc d : ld bc,32 : add hl,bc
	push	de,hl
	ld	a,(hl)
	call	fillTile
	pop	hl,de
	ld	a,(ttt2)
	jp	initBridge
;========================================



doEnemies:    
    ld a,(enemyDelay) : inc a : and 1 : ld (enemyDelay),a
    or a
    ret nz

	ld	a,(gameState)
	cp	GS_GAMEPLAY
;	ret	nz
	jr	z,10F
	cp	GS_BRIDGE
	ret	nz

10:	call	doEnemiesMove
	jp	calcEnemiesSprites

teleportEnemy:
	ld	a,(ix+OBJHERO.isHero)
	or	a		; Is it the hero in demoplay?
	jp	z,teleportHero	; Yes, use hero telport instead
20:	; Teleport an enemy
	ld	(ix+OBJENEMY.yPos),14
	ret

; get local random for enemy
getEnemyRandom:
	push	hl
	inc	(ix+OBJENEMY.rndSeedCounter)
	jr	nz,50F		; Not yet, skip
	; Change the random seed
.chgSeed:
	push	de
	ld	a,r
	ld	e,a
	ld	a,(rndEntropy)
	xor	e
	ld	d,0
	ld	e,a
	ld	hl,beginRAM	; Point to the game variables 
	add	hl,de
	add	(hl)		; Add a random game variable
	ld	e,a
	ld	hl,(xrnd16Seed)
	add	hl,de
	in	a,(#E6)		; Mix with the TR timer
	ld	e,a
	add	hl,de
	ld	a,(rndEntropy)
	ld	e,a
	add	hl,de
	ld	a,r
	ld	e,a
	add	hl,de
	ld	(xrnd16Seed),hl
	call	xrnd16
	ld	a,h
	add	l
	ld	(ix+OBJENEMY.rndSeedCounter),a	; Init the counter
	pop	de
	jr	60F
50:	call	xrnd16
	ld	a,h
	add	l
60:	cp	20		; Reproduce the original game idle percentage
	ld	l,0
	jr	c,20F
	inc	l
	bit	0,a
	jr	z,20F
	inc	l
20:	ld	a,l
	pop	hl
	ret

doEnemiesMove:
	ld	ix,enemiesList    
	ld	b,MAXENEMIES
50:	push 	bc
;	ld	a,(ix+OBJENEMY.xPos);if x coord = 0 we outside screen - disable enemy
;	or	a
;	call	nz,doOneEnemy

	ld	a,(ix+OBJENEMY.yPos) ;if y coord >208 we outside screen - disable enemy
	cp	ENEMY_Y_DISABLE
	call	c,doOneEnemy

	ld	bc,OBJENEMY : add ix,bc
	pop	bc
	djnz	50B
	ret


;try to select a move dir
doLogic:
    ;coords to de
	ld	a,(ix+OBJENEMY.xPos)
	and	#F8		; Don't let errors accumulate
	ld	(ix+OBJENEMY.xPos),a
	ld	e,a
	ld	a,(ix+OBJENEMY.yPos)
	sub	6
	and	#F8		; Don't let errors accumulate
	add	6
	ld	(ix+OBJENEMY.yPos),a
	ld	d,a
.part2:
    ;save previous mode 
    ld a,(ix+OBJENEMY.mode) : ld (ix+OBJENEMY.prevMode),a
    call getTile
    cp TILE_TELEPORT
    call z,teleportEnemy


    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos)
    ;get patrol mode
    ld a,(ix+OBJENEMY.mode)

    cp MODE_PATROL_X
    jp z,doXpatrol

    cp MODE_LADDER
    jp z,doLadder

	cp	MODE_ANGRY
	jp	z,doAngryLogic

    ret

doLadder:    
    ;long ladde fix
    ;check if we at long ladder and there is a land left or right - jump from it
    ;if patrol mode same
    ld a,(ix+OBJENEMY.mode): cp (ix+OBJENEMY.prevMode)
    jr nz,4f
    ;ok check left or right to move
    call getEnemyRandom
    cp 1
    jr z,1f
    call getEnemyRandom
    or a
    jr z,1f

    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de

    ;skip some time this one to move on long ladders
    cp 1
    jr nz,9f    
    call getTile
    dec hl : ld a,(hl)
    cp TILE_SOLID
    jr nc,1f
    ld bc,32 : add hl,bc : 
    ld a,(hl)
    CP TILE_SOLID+1
    jr c,1f
    ld (ix+OBJENEMY.state),ENEMY_LEFT : ld (ix+OBJENEMY.mode),MODE_PATROL_X : jp doXpatrol
9:
    call getTile
    inc hl : ld a,(hl)
    cp TILE_SOLID
    jr nc,1f
    ld bc,32 : add hl,bc
    ld a,(hl)
    CP TILE_SOLID+1
    jr c,1f
    ld (ix+OBJENEMY.state),ENEMY_RIGHT : ld (ix+OBJENEMY.mode),MODE_PATROL_X : jp doXpatrol
1:


4:
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de
    ;get dir
    ld a,(ix+OBJENEMY.state)

    cp ENEMY_UP
    jp z,tryMoveEnemyUp

    cp ENEMY_DOWN
    jp z,tryMoveEnemyDown

    ;set move count
    ld (ix+OBJENEMY.mode),MODE_PATROL_X
    jp doXpatrol

doFallz:
    ;get tile under enemy
    ;ld bc,32 : add hl,bc: ld a,(hl)	
    ;cp TILE_SOLID+1
    ;ret c
    ld a,ENEMY_FALL : ld (ix+OBJENEMY.state),a : jp doXpatrol

tryMoveEnemyDown:    
 
    call getTile
    cp TILE_LADDER : jr nz,doFallz   

	;cp TILE_LADDER : jr z,1f

    ;get tile under enemy
    ld bc,32 : add hl,bc: ld a,(hl)	

	or	a		; Loose end of a ladder?
	jr	z,10F		; Yes, skip
	cp	TILE_LADDER : jr z,1f
	cp	TILE_SOLID :  jr c,1f
2:	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	(ix+OBJENEMY.mode),MODE_PATROL_X : jp doXpatrol
1:
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
    ;continue moving
    ld a,8
    ret

10:	;decide to fall from a edge or switch a dir
	call	getEnemyRandom
	cp	2
	ld	a,8
	ret	z
	; Switch direction 
	ld	e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de    
	ld	(ix+OBJENEMY.state),ENEMY_UP

tryMoveEnemyUp:
    
    call getTile	
    ;get tile above enemy
    ld bc,-32 : add hl,bc: ld a,(hl)	
	
	cp	TILE_LADDER : jr z,1f
	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	(ix+OBJENEMY.mode),MODE_PATROL_X : jp doXpatrol
1:
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
    ;continue moving
    ld a,8

    ret

 DEFINE USEANGRY
 IFDEF USEANGRY
doAngryLogic:
;	; 0.4% of chance of calming down randomly
;	call	xrnd16
;	ld	a,h
;	add	l
;	jp	z,.calmDown
	;check	if we need fall down then skip player scan
	ld	e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de    
	call	getTile
	push	hl			; h=enemyYtile, l=enemyXtile
	pop	iy			; yh=enemyYtile, yl=enemyXtile
	cp	TILE_LADDER
	jp	z,.findHeroLadder
	ld	a,(iy+32)
	cp	TILE_SOLID+1
	jr	nc,.findHeroFloor
	ld	(ix+OBJENEMY.state),ENEMY_FALL
	ld	a,4
	ret
.findHeroFloor:
	ld	a,(iy+32)
	push	iy
	pop	hl
	ld	bc,32
	add	hl,bc
	call	chkBridge
;	ld	(ix+OBJENEMY.mode),MODE_ANGRY
	; Check if we need to turn the face
	ld	a,(ix+OBJENEMY.faceDir)
	cp	FACE_RIGHT
	jr	nz,20F
	ld	a,(iy+1)
	cp	TILE_SOLID+1		; Facing a solid object?
	jr	c,100F			; No, skip
	ld	(ix+OBJENEMY.faceDir),FACE_LEFT
	jr	100F
20:	ld	a,(iy-1)
	cp	TILE_SOLID+1		; Facing a solid object?
	jr	c,100F			; No, skip
	ld	(ix+OBJENEMY.faceDir),FACE_RIGHT
100:	ld	a,(hero.yPos)	; heroY
	add	2			; Hero is taller
	sub	(ix+OBJENEMY.yPos)
	jr	z,.sameRow
	jp	nc,.scanDown
	jp	.scanUp
.sameRow:
	push	iy
	pop	hl			; hl = Enemy coordinates
	ld	a,(hero.xPos)
	cp	(ix+OBJENEMY.xPos)
	jr	nc,.scanRight
.scanLeft:
	; Check if we have linesight to the Hero
;	ld	a,(hero.xPos)	; heroX
	neg
	add	(ix+OBJENEMY.xPos)			; enemyX
	rrca
	rrca
	rrca
	and	#1F			; (enemyX-heroX)/8
	ld	c,a
	ld	b,0
;	ex	af,af'			; af'=Number of tiles to hero
	ld	a,TILE_SOLID+1
	cpdr
	jr	z,.noLinesightLeft
	; We can see the hero. Mindless dash towards him
	ld	(ix+OBJENEMY.state),ENEMY_LEFT
;	ex	af,af'			; Dash towards the hero position
	ld	a,8
	ret

.noLinesightLeft:
	ld	a,(hero.yPos)
	add	2			; Hero is taller
	sub	(ix+OBJENEMY.yPos)
	jr	nc,.scanDownLeft
	jp	.scanUpLeft

.scanDownLeft:
	ld	e,(ix+OBJENEMY.xPos) : ld a,(ix+OBJENEMY.yPos)	; coords to de
	add	8			; Row bellow the enemy
200:	ld	d,a
	call	getTileCoords

.scanDownLeft2:
	ld	a,l
	and	#1F
	dec	a			; Subtract border, +1
	ld	b,a
	ex	af,af'
	ld	de,(TILE_LADDER<<8)+TILE_SOLID+1
320:	ld	a,(hl)
	cp	d			; Ladder?
	jr	z,340F			; Yes, quit
	cp	e			; Can it be stood upon?
	jr	c,340F			; No, skip
	dec	l
	djnz	320B
	scf				; Couldn't find a path
	ret
340:	; Found hole/ladder
	ld	a,(iy-1)
	cp	TILE_SOLID+1		; No exit?
	jp	z,.calmDown		; Yes, calm down
	cp	TILE_FIRE		; Will jump on fire?
	jp	z,.calmDown		; Yes, calm down
	ld	(ix+OBJENEMY.state),ENEMY_LEFT
	ex	af,af'
	sub	b			; Calc distance, clear Cy
	ld	b,a			; b=distance in tles
	ld	a,8
	ret



.scanRight:
	; Check if we have linesight to the Hero
;	ld	a,(hero.xPos)	; heroX
	sub	(ix+OBJENEMY.xPos)	; enemyX
	rrca
	rrca
	rrca
	and	#1F			; (heroX-enemyX)/8
	ld	c,a
	ld	b,0
;	ex	af,af'			; af'=Number of tiles to hero
	ld	a,TILE_SOLID+1
	cpir
	jr	z,.noLinesightRight:
	; We can see the hero. Mindless dash towards him
	ld	(ix+OBJENEMY.state),ENEMY_RIGHT
;	ex	af,af'			; Dash towards the hero position
	ld	a,8
	ret

.scanUp:				; Search for a way up
	ld	e,(ix+OBJENEMY.xPos) : ld a,(ix+OBJENEMY.yPos)	; coords to de
	sub	8			; Row bellow the enemy
	ld	d,a
	call	getTileCoords
;	push	hl
;	pop	iy
;	ld	a,(hero.xPos)
;	cp	(ix+OBJENEMY.xPos)
;	jr	nc,.scanRight
	ld	a,(ix+OBJENEMY.faceDir)
	cp	FACE_RIGHT
	jr	z,200F
	; Scan up, face left
	call	.scanUpLeft2
	ret	nc
	call	.scanUpRight2
	ret	nc
	; Couldn't find a path, calm down
	jp	.calmDown
200:	; Scan up, face right
	push	hl
	call	.scanUpRight2
	pop	hl
	ret	nc
	call	.scanUpLeft2
	ret	nc
	; Couldn't find a path, calm down
	jp	.calmDown




.scanDown:				; Search for a way down
	ld	e,(ix+OBJENEMY.xPos) : ld a,(ix+OBJENEMY.yPos)	; coords to de
	add	8			; Row bellow the enemy
	ld	d,a
	call	getTileCoords
;	push	hl
;	pop	iy
;	ld	a,(hero.xPos)
;	cp	(ix+OBJENEMY.xPos)
;	jr	nc,.scanRight2
	ld	a,(ix+OBJENEMY.faceDir)
	cp	FACE_RIGHT
	jr	z,200F
	; Scan down, face left
	call	.scanDownLeft2
	ret	nc
	call	.scanDownRight2
	ret	nc
	; Couldn't find a path, calm down
	jp	.calmDown

200:	; Scan down, face right
	push	hl
	call	.scanDownRight2
	pop	hl
	ret	nc
	call	.scanDownLeft2
	ret	nc
.calmDown:	; Couldn't find a path, calm down
	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	(ix+OBJENEMY.mode),MODE_PATROL_X
	ld	a,(iy)
	cp	TILE_LADDER
	ld	a,8
	ret	nz
	ld	(ix+OBJENEMY.state),ENEMY_UP
	ld	(ix+OBJENEMY.mode),MODE_LADDER
	ret

.noLinesightRight:
	ld	a,(hero.yPos)
	add	2			; Hero is taller
	sub	(ix+OBJENEMY.yPos)
	jp	nc,.scanDownRight
	jr	.scanUpRight

.scanDownRight:
	ld	e,(ix+OBJENEMY.xPos) : ld a,(ix+OBJENEMY.yPos)	; coords to de
	add	8			; Row bellow the enemy
	ld	d,a
	call	getTileCoords

.scanDownRight2:
	ld	a,l
	and	#1F
	neg
	add	30			; a=30-xTilePos
	ld	b,a
	ex	af,af'
	ld	de,(TILE_LADDER<<8)+TILE_SOLID+1
320:	ld	a,(hl)
	cp	d			; Ladder?
	jr	z,340F			; Yes, quit
	cp	e			; Can it be stood upon?
	jr	c,340F			; No, skip
	inc	l
	djnz	320B
330:	call	.calmDown
	scf
	ret
340:	; Found hole/ladder
	ld	a,(iy+1)
	cp	TILE_SOLID+1		; No exit?
	jp	z,.calmDown		; Yes, calm down
	cp	TILE_FIRE		; Will jump on fire?
	jp	z,.calmDown		; Yes, calm down
	ld	(ix+OBJENEMY.state),ENEMY_RIGHT
	ex	af,af'
	sub	b			; Calc distance, clear Cy
	ld	b,a			; b=Distance in tiles
	ld	a,8
	ret

.scanUpLeft:
	ld	e,(ix+OBJENEMY.xPos) : ld a,(ix+OBJENEMY.yPos)	; coords to de
	sub	8			; Row bellow the enemy
	ld	d,a
	call	getTileCoords
.scanUpLeft2:
	ld	a,l
	and	#1F
	dec	a			; Subtract border, +1
	ld	b,a
	ex	af,af'
	ld	de,(TILE_LADDER<<8)+TILE_SOLID+1
420:	ld	a,(hl)
	cp	d			; Ladder?
	jr	z,440F			; Yes, quit
	cp	e			; Can it be stood upon? 
	jr	nc,440F			; Yes, quit
	dec	l
	djnz	420B
430:	call	.calmDown
	scf				; Couldn't find a path
	ret
440:	; Found hole/ladder
	ld	a,(iy-1)
	cp	TILE_SOLID+1		; No exit?
	jp	z,.calmDown		; Yes, calm down
	cp	TILE_FIRE		; Will jump on fire?
	jp	z,.calmDown		; Yes, calm down
	ld	(ix+OBJENEMY.state),ENEMY_LEFT
	ex	af,af'
	sub	b			; Calc distance, clear Cy 
	ld	b,a			; b=distance in tiles
	ld	a,8
	ret


.scanUpRight:
	ld	e,(ix+OBJENEMY.xPos) : ld a,(ix+OBJENEMY.yPos)	; coords to de
	sub	8			; Row bellow the enemy
	ld	d,a
	call	getTileCoords
.scanUpRight2:
	ld	a,l
	and	#1F
	neg
	add	30			; a=30-xTilePos
	ld	b,a
	ex	af,af'
	ld	de,(TILE_LADDER<<8)+TILE_SOLID+1
520:	ld	a,(hl)
	cp	d			; Ladder?
	jr	z,540F			; Yes, quit
	cp	e			; Barrier?
	jr	nc,530F			; Yes, quit
	inc	l
	djnz	520B
530:	scf
	ret
540:	; Found hole/ladder
	ld	a,(iy+1)
	cp	TILE_SOLID+1		; No exit?
	jp	z,.calmDown		; Yes, calm down
	cp	TILE_FIRE		; Will jump on fire?
	jp	z,.calmDown		; Yes, calm down
	ld	(ix+OBJENEMY.state),ENEMY_RIGHT
	ex	af,af'
	sub	b			; Calc distance, clear Cy 
	ld	b,a			; b=distance in tiles
	ld	a,8
	ret


.findHeroLadder:
	ld	a,(hero.yPos)
	add	2			; Hero is taller
	sub	(ix+OBJENEMY.yPos)
	jp	z,.findHeroFloor
	jr	nc,400F
	ld	a,(iy-32)		; Hero is above
	cp	TILE_LADDER
	jp	nz,.findHeroFloor
	ld	(ix+OBJENEMY.state),ENEMY_UP
	ld	a,8
	ret
400:	ld	a,(iy+32)		; Hero is below
	cp	TILE_SOLID+1
	jp	nc,.findHeroFloor
	ld	(ix+OBJENEMY.state),ENEMY_DOWN
	ld	a,8
	ret


 ENDIF


doXpatrol:

    ;check if we need fall down then skip player scan
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de    
    call getTile
    ld bc,32:add hl,bc : ld a,(hl)
    cp TILE_LADDER
    jr z,1f
    cp TILE_SOLID
    jp c,000f			; Skip if not solid
1:
	ld	a,(ix+OBJHERO.isHero)
	or	a		; Is it the hero in demoplay?
	jp	z,000F		; Yes, skip scan
	;check Y delta
	ld a,(hero.yPos)       
    sub (ix+OBJENEMY.yPos)        
    add a,4  ;4          
    cp 6;6                
    jp nc,000f             
    ;ok,start scan in face direction
    ;get face direction
    ld a,(ix+OBJENEMY.faceDir)
    cp FACE_RIGHT
    jr nz,1f
;scan right
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de    
    call getTileCoords
    push hl : pop iy
    ld e,(ix+OBJENEMY.xPos)

    ld b,SCANLENGTH
44:
    ld a,(iy+1)
    cp TILE_SOLID+1
    jr nc,000f
    ld a,(iy+32+1)
    cp TILE_LADDER
    jr z,3f
    cp TILE_SOLID
    jr c,000f
3:
    ;ok
    ld a,e : add 8
    ;check enf of screen
    cp 256-16 : jr nc,000f
    ld e,a    

    ld e,a    
    ld a,(hero.xPos)
    ;compare with hero x
    sub e    
	add a,3
	cp 6     
    ;jr nc,2f
    ;ok we found a hero!    
    ;set move dir to right and exit
;	call	getEnemyRandom		; Might get angry
;	or	a
;	jp	nz,getAngry
;    ld (ix+OBJENEMY.state),ENEMY_RIGHT:ld a,8 : ret
	jp	c, getAngry
2:
    inc iy
    djnz 44b
    jr 000f

;scan left
1:
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de    
    call getTileCoords
    push hl : pop iy
    ld e,(ix+OBJENEMY.xPos); : ld a,e : sub 4 : ld e,a

    ld b,SCANLENGTH
44:
    ld a,(iy-1)
    cp TILE_SOLID+1
    jr nc,000f

    ld a,(iy+32-1)
    cp TILE_LADDER
    jr z,3f
    cp TILE_SOLID   
    jr c,000f
3:
    ;ok
    ld a,e : sub 8
    ;check enf of screen
    or a : jr z,000f
    ld e,a    

    ld a,(hero.xPos)
    ;compare with hero x
    sub e    
	add a,3  
	cp 6     
;    jp nc,2f
    ;ok we found a hero!    
    ;set move dir to right and exit
;	call	getEnemyRandom		; Might get angry
;	or	a
;	jp	nz,getAngry
;    ld (ix+OBJENEMY.state),ENEMY_LEFT:ld a,8 : ret
	jp	c,getAngry
2:
    dec iy
    djnz 44b
;    jp 000f

000:	; Check the tiles on enemy position and below him

    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de    
    ;check falling and bridge builder
    call getTile        
	cp TILE_LADDER : jr z,1f

    ;get tile under enemy
    ld bc,32 : add hl,bc: ld a,(hl)	

8:
	cp TILE_SOLID+1 :  jr nc,1f
    ;ok, not solid - fall
    ld (ix+OBJENEMY.state),ENEMY_FALL : ld a,4 : ret

1:  
    ;check if we was falling then IDLE
    ld a,(ix+OBJENEMY.state)
    cp ENEMY_FALL
    jr nz,3f
    ;IDLE AFTER FALL
    ld (ix+OBJENEMY.state),ENEMY_IDLE
    jr 4f

3:	; Wasn't falling
    ;if there was IDLE - set random x dir
    cp ENEMY_IDLE
    jr nz,4f ;continue moving
    ;get next dir random after falling
    call getEnemyRandom
    ld (ix+OBJENEMY.state),a
;    jr 4f   

4:	; Check ladder, blocks under enemy and bridge
	call	chkBridge    

20:   ;checkLadder and climb: start a ladder
	ld	a,(ix+OBJENEMY.prevMode)
	cp	MODE_LADDER	; Was on the ladder before?
	jr	z,6F		; Get out!
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos)
    call getTile
    cp TILE_LADDER
    jr nz,6f
    push hl
    call getEnemyRandom
    pop hl
    cp 1	; Randomly ignore the ladder
    jr nz,6f

    ;ok - switch to ladder mode
    ld (ix+OBJENEMY.mode),MODE_LADDER

    ;check if up and down lader - long lader here
    ld bc,-32:add hl,bc:ld a,(hl)
    cp TILE_LADDER
    jr nz,1f
    ld bc,64:add hl,bc : ld a,(hl)
    cp TILE_LADDER
    jr nz,1f
    ;ok up down ladders, get random dir
    call getEnemyRandom
    cp 1
    jr nz,3f
    ld (ix+OBJENEMY.state),ENEMY_UP
    jp doLadder
3:
    ld (ix+OBJENEMY.state),ENEMY_DOWN
    jp doLadder

;=========================================
1:	; Check ladder top and bottom
    ld (ix+OBJENEMY.state),ENEMY_UP;set enemy up dir
    ld bc,-32 : add hl,bc; if no ladder above head move move down
    ld a,(hl)
    cp TILE_LADDER
    jr z,7f
    ld (ix+OBJENEMY.state),ENEMY_DOWN
    ;jp doLadder
7:      
    jp doLadder
6:


    ;randomly enable idle :)
    call getEnemyRandom        
    ;ok,check if we need a change dir
    or a
    jr nz,2f
    ld (ix+OBJENEMY.state),ENEMY_IDLE

    ;contidue moving
2:
    ld a,(ix+OBJENEMY.state)
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de


    ;check tile at new position
    cp ENEMY_RIGHT
    jp z,tryMoveEnemyRight
    cp ENEMY_LEFT
    jp z,tryMoveEnemyLeft

    cp ENEMY_IDLE
    jp z,doEnemyIdle

    ;set count to 8
    ld a,8
    ret

getAngry:
	ld	(ix+OBJENEMY.mode),MODE_ANGRY
	jp	doAngryLogic

doEnemyIdle:
    ld a,32 : ret

tryMoveEnemyRight:
    ld a,e : add 8 : ld e,a
    call getTile	
    cp TILE_SOLID+1
    jp nc,switchHDir

	push	hl
	pop	iy
	; Check the tile behind me
	ld	a,(iy-2)
	cp	TILE_SOLID+1
	jr	nc,10F		; No choice. Have to move forward

    ;check what under legs
	ld	a,(iy+32)
    cp TILE_LADDER
    jr z,10f
    cp TILE_SOLID+1
    jr c,tryToFall
10: ;set move count
	ld a,8
    ret

tryMoveEnemyLeft:
    ld a,e : sub 8+4
;	jr	nc,20F
;	ld	a,248		; Warp to the right
;	ld	(ix+OBJENEMY.xPos),a
20:	ld	e,a
    call getTile	
    cp TILE_SOLID+1
    jp nc,switchHDir

	push	hl
	pop	iy
	; Check the tile behind me
	ld	a,(iy+2)
	cp	TILE_SOLID+1
	jr	nc,10F		; No choice. Have to move forward

    ;check what under legs
	ld	a,(iy+32)
    cp TILE_LADDER
    jr z,10F
    cp TILE_SOLID+1
    jr c,tryToFall
10: ;set move count
	ld a,8
    ret

;decide to fall from a edge or switch a dir
tryToFall:
    call getEnemyRandom
    ;or a
    cp 2
    ld a,8
    ret z
    ;call getEnemyRandom
    ;cp 1
    ;ld a,8
    ;ret z
	; Switch direction without bumping
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
	ld	a,(ix+OBJENEMY.state)
	cp	ENEMY_RIGHT
	ld	a,8
	ld	(ix+OBJENEMY.state),ENEMY_LEFT
	ld	(ix+OBJENEMY.faceDir),FACE_LEFT
	ret	z
	ld      (ix+OBJENEMY.state),ENEMY_RIGHT
	ld	(ix+OBJENEMY.faceDir),FACE_RIGHT
	ret

switchHDir:	; Only when bumped on something
    	ld	de,(ix+OBJENEMY.xPos)
	call	getTileCoords
	dec	(ix+OBJENEMY.deadEndTtl)
	jr	z,killEnemy
	ld	a,(ix+OBJENEMY.deadEndTtl)
	cp	DEADENDTTL/2
	jr	nc,5F
	; At least try to climb out before killing himself
	ld	a,(hl)
	cp	TILE_LADDER
	jp	z,tryMoveEnemyUp
5:	ld	a,(ix+OBJENEMY.state)
	CP	ENEMY_RIGHT
	jr	nz,1f
	ld	(ix+OBJENEMY.state),ENEMY_LEFT
	ld	(ix+OBJENEMY.faceDir),FACE_LEFT
	;check if we're in a hole
	push	hl
	pop	iy
	ld	a,(iy-1)
	cp	TILE_SOLID+1
	jr	c,10F
	ld	a,(iy+32)
	cp	TILE_SOLID+1
	jr	c,10F
	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	(ix+OBJENEMY.mode),MODE_PATROL_X
10:	ld	a,8
	ret  
1:
	ld	(ix+OBJENEMY.state),ENEMY_RIGHT
	ld	(ix+OBJENEMY.faceDir),FACE_RIGHT
	;check if we're in a hole
	push	hl
	pop	iy
	ld	a,(iy+1)
	cp	TILE_SOLID+1
	jr	c,20F
	ld	a,(iy+32)
	cp	TILE_SOLID+1
	jr	c,20F
	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	(ix+OBJENEMY.mode),MODE_PATROL_X
20:	ld	a,8
	ret  

killEnemy:
	ld	(ix+OBJENEMY.state),ENEMY_IDLE
    ;set dead count
    ld a,128 : ld (ix+OBJENEMY.deathTimer),a
	jp	enemyDeadSound

hideEnemy:
    ;move to limbo
    ld (ix+OBJENEMY.yPos),ENEMY_Y_LIMBO
    di : ld a,10 : ld c,0 : call ayFX_INIT : ei;15-low 0 -high
    ;ld a,10 : call AFXPLAY3
    ret
doEnemyDead:
    dec a
    ld (ix+OBJENEMY.deathTimer),a
    cp 128-32
    jr z,hideEnemy
    ld a,(ix+OBJENEMY.deathTimer)
    or a    
    ret nz

    ld a,(ix+OBJENEMY.moveCounter)
    ;not to kill enemy frame logic smashing just add to current move count
   add 64    
    ld (ix+OBJENEMY.moveCounter),a

	; Respawn the enemy
	ld	(ix+OBJENEMY.state),ENEMY_IDLE
	ld	(ix+OBJENEMY.mode),MODE_PATROL_X
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
    ;move to start point
    ld a,(ix+OBJENEMY.startX) : ld (ix+OBJENEMY.xPos),a
    ld a,(ix+OBJENEMY.startY) : ld (ix+OBJENEMY.yPos),a
    ;ld a,11 : call AFXPLAY3
    di : ld a,17 : ld c,0 : call ayFX_INIT : ei;15-low 0 -high
    ret

;ix - enemy pointer
doOneEnemy:
    ;check if we not dead then check for dead
    ld a,(ix+OBJENEMY.deathTimer)
    or a
    jr nz,doEnemyDead

    ;ok we live
    ;check dead on fire and spikes
    ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de
    ;ld a,d : add 4 : ld d,a
    call getTile
    cp TILE_FIRE
    jp z,killEnemy
    cp TILE_PIKE
    jp z,killEnemy


1:

    ;check if moveCount = 0 then try to select a move dir
    ;else we move

    ld a,(ix+OBJENEMY.moveCounter)
    or a
    call z,doLogic
    ;else move
    dec a
    ld (ix+OBJENEMY.moveCounter),a
    

    ;ld e,(ix+OBJENEMY.xPos) : ld d,(ix+OBJENEMY.yPos);coords to de
    ;get state
	ld	a,(ix+OBJENEMY.state)
	cp	ENEMY_RIGHT
	jr	z,moveEnemyRight
	cp	ENEMY_LEFT
	jr	z,moveEnemyLeft
	cp	ENEMY_FALL
	jr	z,fallEnemy

	cp	ENEMY_DOWN
	jr	z,downEnemy

	cp	ENEMY_UP
	jr	z,upEnemy

	cp	ENEMY_IDLE
	jr	z,idleEnemy

	ret

downEnemy:
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
    ld c,(SPR_ENEMY_BMPBASE+4)*4 
    ld a,(ix+OBJENEMY.animCounter)
    add a,a : add a,a
    add c
    ld (ix+OBJENEMY.sprFrame),a
;move down
    inc (ix+OBJENEMY.yPos)
    ret

upEnemy:
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
    ld c,(SPR_ENEMY_BMPBASE+4)*4 
    ld a,(ix+OBJENEMY.animCounter)
    add a,a : add a,a
    add c
    ld (ix+OBJENEMY.sprFrame),a

;move down
    dec (ix+OBJENEMY.yPos)
    ret

fallEnemy:
	ld	(ix+OBJENEMY.deadEndTtl),DEADENDTTL
;update sprites    
    ld c,(SPR_ENEMY_BMPBASE+6)*4 
    ld a,(ix+OBJENEMY.animCounter)
    add a,a : add a,a
    add c
    ld (ix+OBJENEMY.sprFrame),a

;move down
	inc	(ix+OBJENEMY.yPos)
	inc	(ix+OBJENEMY.yPos)
	ld	a,(ix+OBJENEMY.yPos)
	cp	192-4
	ret	c
	jp	teleportEnemy

idleEnemy:
	ld	a,(ix+OBJENEMY.faceDir) ; idle direction
	dec	a	:	add	a	: add	a	: add	a
	add	SPR_ENEMY_BMPBASE*4	:	ld	c,a
	ld	a,(ix+OBJENEMY.animCounter) : add a,a : add a,a : add c

	ld	(ix+OBJENEMY.sprFrame),a
	ret

moveEnemyRight: 
    ;save face position
    ld (ix+OBJENEMY.faceDir),FACE_RIGHT

    ld c,(SPR_ENEMY_BMPBASE+16)*4 
    ld a,(ix+OBJENEMY.moveCounter)
    add a,a : add a,a
    add c
    ld (ix+OBJENEMY.sprFrame),a

    inc (ix+OBJENEMY.xPos);x coords
    ret

moveEnemyLeft:    
    ;save face position
    ld (ix+OBJENEMY.faceDir),FACE_LEFT

    ld c,(SPR_ENEMY_BMPBASE+8)*4 
    ld a,(ix+OBJENEMY.moveCounter)
    add a,a : add a,a
    add c
    ld (ix+OBJENEMY.sprFrame),a
    
    dec (ix+OBJENEMY.xPos);x coords
    ret

; rndX: incbin "include\rndX.bin"

