

;system vars
;MSXVER EQU $002D
;FORCLR EQU $F3E9 ;Foreground colour
;BAKCLR EQU $F3EA ;Background colour
;BDRCLR EQU $F3EB ;Border colour
;CLIKSW EQU $F3DB ;0 disabled / 1 enabled
;RG1SAV EQU $F3E0 ;VDP REG 1
;EXTVDP EQU $FFE7 ;

/*
VDPInitValues:
;set shrinked graphics 2 mode without splits of thirds
  ;db 00000010b ;graphics2, not externa video
  ;db 11000010b ;16kb,enable display,disable int,16x16sprites,mag off
  ;db 00001110b ;nametable at $3800
  ;db 10011111b ;color table at $2000-$2800 
  ;db 00000000b ;patern table 0-$0800
  ;db 01110110b  ;sprite attributes $3b00
  ;db 00000011b ;sprite pattern in vram $1800
  ;db 00000000b ;backcolor WHITE

;set standart mode 2
  ;db 00000010b ;graphics2, not externa video
  ;db 11000010b ;16kb,enable display,disable int,16x16sprites,mag off
  ;db 00001110b ;nametable at $3800
  ;db 11111111b ;color table at $2000 
  ;db 00000011b ;patern table 0-$0000
  ;db 01110110b  ;sprite attributes $3b00
  ;db 00000011b ;sprite pattern in vram $1800
  ;db 00001111b ;backcolor WHITE
*/

;-----------------------------------------------
; returns 1 in a and clears z flag if vdp is 60Hz
checkIf60Hz:
	ld	a,(MSXVER)
	or	a
	jr	nz,.msx2
;MSX1:
	ei
	halt
	di
	ld	bc,3
10	call	RDPSG		; Dummy read of the PSG to force the
				; SuperTurbo to keep the low clock
	djnz	10B	
	dec	c
	jr	nz,10B
	call	RDVDP
	rlca
	ei
	jr	.end

.msx2:	; MSX2 or higher
	ld	a,(RG9SAV)
	cpl
	rrca
.end:	and	1
	ld	(is60),a	; 1 = NTSC
	ret

;-----------------------------------------------

initGame:
	ld	a,(CHGCPU)
	cp	#C3		; Is CHGCPU present?
	ld	a,#82
	call	z,CHGCPU	; Yes, enable the turbo

	call	BASEMSXLIB.getfrm1slot  
	ld	h,#80        ; move page 1 of the ROM to page 2 in main memory
	call	ENASLT    
	di
	; Get a seed for the Random number Generator from the uninitialized RAM
	ld	hl,#8000
	ld	d,l
	ld	bc,256*(LOW (#F380-#8000))+HIGH (#F380-#8000)
10:	ld	e,(hl)
	inc	hl
	add	ix,de
	djnz	10B
	dec	c
	jr	nz,10B

	; clear the RAM
	ld	hl,beginRAM
	ld	de,beginRAM+1
	ld	bc,endRAM-beginRAM-1
	ld	(hl),0
	ldir
	ld	(xrnd16Seed),ix

	ld	hl,palSel.msx1clr
	ld	a,(MSXVER)
	or	a
	call	nz,palSel.setPal

	; Init variables
	xor	a
	ld	(CLIKSW),a
	dec	a		; a=#FF
	ld	hl,joyStatus
	ld	b,jport2HIDprot-joyStatus+1
20	ld	(hl),a
	inc	hl
	djnz	20B
	ld	a,START_LEVEL-1
	ld	(demoLevel),a
;	ld	a,#1B
;	ld	(satBackBuf),a

  	ld	hl,baseStatusText : ld	de,statusText:ld	bc,35 : ldir
	ld	hl,outroText : ld	(outroString),hl
	ld	hl,spritesTable+VDPSPR
	ld	(spritePtr),hl
	ld	a,MAXFRM
	ld	(gmframes),a
	; Save Hooks
	ld	hl,HTIMI
	ld	de,oldHTIMI
	ld	bc,5
	ldir
	; Install Hooks
	ld	a,#C9
	ld	(HKEYI),a
	ld	a,#C3
	ld	(HTIMI),a
	ld	hl,frmIntHdl
	ld	(HTIMI+1),hl
	ld	a,MAXFRM
	ld	(gmframes),a
	xor	a
	ld	(mpbusy),a
    	ei
	call	checkIf60Hz
  	jp	initAYFX

initGameplay:
	call	clearScreen
  ;init RAM variables
	ld	a,(gameSubState)
	cp	GSS_GAMEPLAY_DEMOPLAY
  	ld	a,START_LEVEL
	jr	nz,20F
	ld	a,(demoLevel)
	inc	a
	cp	LASTLEVEL+1
	jr	c,10F
	ld	a,START_LEVEL
10:	ld	(demoLevel),a
20:	ld	(currentLevel),a
  ld a,START_LIVES	: ld	(heroLives),a
  xor a
	ld	(outroCount),a
  ld (fireFrame),a : ld (fireDelay),a
  inc a : ld (goldDelay),a
	ld	hl,DEMOWAIT
	ld	(demoTimer),hl

initVDP:

  ;set colors
  ;ld a,00000000b : ld c,7 : call writeRegister
  ;set mode 2
  ;ld a,00000010b : ld c,0 : call writeRegister
  ;ld a,11000010b : ld c,1 : call writeRegister

  ;color ,5,5  
 ; ld   A,1 : ld   (BAKCLR),A
 ; ld   A,1 : ld   (BDRCLR),A  
 ; call CHGCLR
;set screen2 mode
;	ld   a,2
;	call CHGMOD  
  ;; 16x16 sprites:
  ld bc,#e201  ;; write #e2 in VDP register #01 (activate sprites, generate interrupts, 16x16 sprites with no magnification)
  call WRTVDP

  
   ;ld hl,VDPInitValues : call initVDP

   ;dill nametable with zero
   call clearScreen

   ;fill VDP memmory with tiles
   jp	fillVDP

;==========register access
;                         MSB  7   6   5   4   3   2   1   0  LSB
;                        +---+---+---+---+---+---+---+---+
;   Port #1 First byte   |D7 |D6 |D5 |D4 |D3 |D2 |D1 |D0 | DATA
;                        +===+===+===+===+===+===+===+===+
;           Second byte  | 1 | 0 |R5 |R4 |R3 |R2 |R1 |R0 | REGISTER #
;

;init VDP from HL -8 regs of vdp 
/*
initVDP8:
    ld c,0
   ld b,8
1:
    ld a,(hl) : call writeRegister
    inc hl : inc c
    djnz 1b
    ret

;a-value c -register
writeRegister:
    di
    out (#99),a
    ld a,c : add 128
    ei
    out (#99),a
    ret
  */


  ;system vars
;MSXVER     EQU $002D

BASE11	EQU	$2000 ;base 11 color table
BASE12	EQU	$0000 ;base 12 character pattern table


showIntroPicture:

  ;unpack picture to VRAM
	;color ,5,5  
  ld   A,1
  ld   [BAKCLR],A
  ld   A,1
  ld   [BDRCLR],A  
  call CHGCLR
	
	;screen 2
	ld   A,2
	call CHGMOD

	call	myDISSCR ;disable screen

	ld	hl,TILESET_pat
	ld	de,map
	call	DEC40
	ld	hl,map
	ld	de,BASE12
	ld	bc,#1800
	call	LDIRVM

	ld	hl,TILESET_col
	ld	de,map
	call	DEC40
	ld	hl,map
	ld	de,BASE11
	ld	bc,#1800
	call	LDIRVM

	call	myENASCR ;enable screen

	; Reset the timer
	ld	hl,0
	ld	(timer),hl

	ld	de,10*50+0x100	; 8 seconds
20:	halt
	ld	a,(joyPressed)
	cpl
	or	a		; Any button pressed?
	jr	nz,30F		; Yes, quit
	ld	hl,(timer)
	rst	DCOMPR
	jr	c,20B
30:

showMenuPicture:
	call	myDISSCR ;disable screen

	ld	hl,mTILESET_pat
	ld	de,map
	call	DEC40
	ld	hl,map
	ld	de,BASE12
	ld	bc,#1800
	call	LDIRVM

	ld	hl,mTILESET_col
	ld	de,map
	call	DEC40
	ld	hl,map
	ld	de,BASE11
	ld	bc,#1800
	call	LDIRVM

	jp	myENASCR ;enable screen

; Dynamic Vsync
dynVsync:
	ld	b,TGTFRMSKP+1	; Get the target framerate + framerate we
				; just processed + force carry for zero
	ld	hl,gmframes
	ld	a,(hl)
	sub	b
	jr	nc,20F
10:	halt
	ld	a,(hl)
	cp	b
	jr	c,10B
	xor	a
20:	ld	(hl),a
	ret

.frameCounter:
	ld	hl,gmframes
	ld	a,(hl)
	inc	a
	cp	MAXFRM		; Don't memorize more frames than it should
	ret	nc
	ld	(hl),a
	ret


genRndTransitionTable:
	; Input:
	; de=Destination of the FX transition table

	; Generate a list of random values that will be used to shuffle the
	; list of map coordinates
	push	de,de
	ex	de,hl
	ld	hl,(xrnd16Seed)
	ld	bc,(JIFFY)
	add	hl,bc
	ld	b,0
	ld	a,r
	ld	c,a
	add	hl,bc
	set	0,l		; Be sure that the seed won't be started with 0
	ld	(xrnd16Seed),hl
	ex	de,hl
	call	xrnd16
	ld	a,h
	add	l
	ld	(rndEntropy),a	; Kickstart the enemy RND generator

	; Fill an initial FX table with a sequential list of unique map
	; coordinates
	pop	hl
	ld	b,23	; 32 columns, 23 lines
	ld	de,#0100	; map y=1, x=0
50:	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	inc	e
	bit	5,e
	jr	z,50B
	ld	e,0
	inc	d
	djnz	50B	
	ld	(hl),#FF
	inc	hl
	ld	(hl),#FF

	pop	ix
	ld	e,2		; Two passes
20:	ld	bc,LOW (32*23)*256 + HIGH (32*23)	; 32x23 words matrix
30:	exx
	call	.getRndIndex
	ex	de,hl
	call	.getRndIndex
	; Swap random pairs of tile coordinates
	ld	c,b		; To keep B from being incremented on LDI
	ld	a,(de)
	ldi
	ld	b,a
	ld	a,(de)
	ldi
	dec	hl
	ld	(hl),a
	dec	hl
	ld	(hl),b
	exx
	djnz	30B
	dec	c
	jr	nz,30B
	dec	e
	jr	nz,20B
	ret

.getRndIndex:
	call	xrnd16
	ld	a,h
	and	3
	cp	HIGH (32*23-1)
	jr	nc,90F
	jr	nz,100F
	ld	a,l
	cp	LOW (32*23)
	jr	c,100F
	ld	a,h
90:	res	5,l
	and	#FE
100:	sla	l
	adc	a
	ld	h,a	
	ld	bc,ix
	add	hl,bc
	ret

;==========================================================================

waitVBL:
	ld	a,1
	jr	20F

haltDelay:		; The MSX has many devices that may generate interrupts
			; we have to be sure that they came from the VDP
			; vertical interrupt
	ld	a,b
20:	ld	(timerVbl),a
	ei
10:	halt
	ld	a,(timerVbl)
	or	a		; Is it a frame interrupt? 
	jr	nz,10B		; No, wait
	ret

;-----------------------------------------------
playMusic:
	ld	hl,mpbusy
	rlc	(hl)		; Is the Music replayer busy?
	ret	c
	set	7,(hl)
	call	PT3_PLAY	; play to AY_REGS
        call	ayFX_PLAY
	call	PT3_ROUT	; write to AY from AY_REGS
	xor	a
	ld	(mpbusy),a
	ret

;-----------------------------------------------
; Frame interrupt handler
frmIntHdl:
	ei
 IFDEF PROFILER
	ld	bc,#0807	; Interrupt handler = Red 
	call	WRTVDP
 ENDIF
	call	gameInt
 IFDEF PROFILER
	ld	bc,#0107	; Black = end
	call	WRTVDP
 ENDIF ; PROFILER
	ld	hl,10
	ld	(INTCNT),hl
	ld	a,l		; Disable the BIOS keyboard/STRIG processing
	ld	(SCNCNT),a
	ret

gameInt:
	; Frame rate adjust
	ld	a,(is60)
	or	a		; Is it NTSC?
	jr	z,40F		; No, just play
	; skip every 6 frame on NTSC
	ld	hl,mpframes
	ld	a,(hl)
	inc	a
	ld	(hl),a
	cp	6
	jr	c,40F
	xor	a
	ld	(hl),a
	ret
40:	call	palSel
	ld	hl,(timer)
	inc	hl
	ld	(timer),hl
	ld	a,(timerVbl)
	dec	a
	jp	m,50F
	ld	(timerVbl),a
50:	call	readJoy1KbdStatus
	call	playMusic
	call	rndHelper
	jp	dynVsync.frameCounter

rndHelper:
	ld	hl,joyStatus
	ld	b,7
	ld	a,(rndEntropy)
10:	sub	(hl)
	inc	hl
	djnz	10B
	ld	l,a
	ld	a,(MSXVER)
	cp	3		; MSXTR?
	ld	a,l
	jr	c,20F
	in	a,(#A5)		; Get the TR PCM status
	xor	l
20:	ld	(rndEntropy),a
	ret

palSel:		; Select the palette
	ld	a,(MSXVER)
	or	a
	ret	z
	ld	a,(fnBtnPressed)
	cp	~#01		; F1 pressed?
	ld	hl,.msx1clr
	jr	z,.setPal
	cp	~#02		; F2 pressed?
	ld	hl,.msx2clr
	jr	z,.setPal
	cp	~#04		; F3 pressed?
	ld	hl,.coolColors
	jr	z,.setPal
	cp	~#08		; F4 pressed?
	ld	hl,.zxclr
	jr	z,.setPal
	cp	~#10		; F5 pressed?
	ld	hl,.c64clr
	jr	z,.setPal
	ret

.setPal:
	xor	a		;Set p#pointer to zero.
	ld	bc,(VDP.DW)
	inc	c
	di
	out	(c),a
	ld	a,16+128
	ei
	out	(c),a
	ld	b,#20		;out 32x to port 8Ah/9Ah
	inc	c
	otir
	ret

.msx1clr:
	INCBIN	"gfx/palettes/MSX1YUV.PLT"
.msx2clr:
	INCBIN	"gfx/palettes/MSX2.PLT"
.coolColors:
	INCBIN	"gfx/palettes/COOLCOLR.PLT"
.zxclr:
	INCBIN	"gfx/palettes/SPECTRUM.PLT"
.c64clr:
	INCBIN	"gfx/palettes/C64.PLT"


chkDiskChange:	; Checks if the disk has changed
stopDrive:	; stops the drive. Will stop the drive on interfaces that
		; use HTIMI to do this.
		; Both use the same routine, but have different names to
		; make the code easier to understand.
		; Modifies: all except AF
	ld	b,0
	push	af
20:	push	bc
	call	oldHTIMI
	pop	bc
 	djnz	20B
	pop	af
	ret

