
readHID:	; ix: pointer to HIDprotID
		; d: PSG R#15 as required by JOYLIB.GTJOYSEL
		; e: Pulse mask as required by JOYLIB.GTJOYSEL
	ld	a,(ix)
	cp	HIDID.JOYMEGA
	jr	z,.joymega
	cp	HIDID.MOUSE
	jr	z,.mouse
;.MSXjoy:
	call	JOYLIB.GTJOYDIG
	ret	nc
	jr	.protochg	; Different protocol was found
.joymega:	
	call	JOYLIB.GTJOYMEG3
	ret	nc
.disconnect:
	ld	a,HIDID.MSXJOY	; Joymega disconnected. Reset protocol
.protochg:			; Will ignore anything non-joystick
	ld	(ix),a
	ld	a,#FF
	ld	b,a
	ret

.mouse:		; Mice can be a source of some entropy
	call	._rdmousebyte
	ld	l,a
	call	._rdmousebyte
	cp	l
	jr	nz,20F	
	cp	1
	jr	z,.disconnect
20:	add	l
	ld	l,a
	ld	a,(rndEntropy)
	add	l
	ld	(rndEntropy),a
	ld	a,#FF
	ld	b,a
	ret

._rdmousebyte:
	call	BASELIB.FLIPPORTOUT	; flip output to high
	ex	(sp),hl
	ex	(sp),hl
	ex	(sp),hl
	ex	(sp),hl
	call	BASELIB.RDJOYPORT
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	ld	b,a
	call	BASELIB.FLIPPORTOUT	; flip output to low
	ex	(sp),hl
	ex	(sp),hl
	ex	(sp),hl
	ex	(sp),hl
	call	BASELIB.RDJOYPORT
	ld	c,a			; c=PSG R#14
	and	#0F
	or	b
	neg
	ret


readJoy1KbdStatus:
	; Use MSX-HID detection to avoid conflict with mice, touchpad, paddles
	; etc

	ld	a,(joyStatus)
	push	af			; (sp)=old joyStatus
	call	JOYLIB.GTKBDJOY
	ld	(joyStatus),a

	ld	ix,jport1HIDprot
	ld	de,#108F
	call	readHID
	ld	hl,(joyStatus)
	and	l
	ld	(joyStatus),a
	ld	ix,jport2HIDprot
	ld	de,#20CF
	call	readHID
	ld	hl,(joyStatus)
	and	l
	ld	(joyStatus),a
	pop	hl			; h=old joyStatus
	xor	h			; Transition?
	and	h			; Descending border?
	cpl
	ld	(joyPressed),a
	ld	hl,(joyPressedGam)
	and	l
	ld	(joyPressedGam),a

.rdFnButtons:	; Read buttons that require on-press detection to avoid
		; repetition
	ld	a,6
	call	SNSMAT
	or	#1F
	ld	b,a
	ld	a,7
	call	SNSMAT
	or	#E0
	and	b
	rlca
	ld	b,a			; b=F2,F1,STOP,TAB,ESC,F5,F4,F3
	ld	a,(joyStatus)
	or	#DF
	and	b			; Button2 = STOP
	rlca
	rlca
	ld	hl,(fnBtnStatus)	; l=old fnBtnStatus
	ld	(fnBtnStatus),a		; STOP,TAB,ESC,F5,F4,F3,F2,F1
	xor	l			; Transition?
	and	l			; Descending border?
	cpl
	ld	(fnBtnPressed),a	; STOP,TAB,ESC,F5,F4,F3,F2,F1
	ld	a,4
	call	SNSMAT
	ld	(kbdRow4Status),a
	ret

	include "asmlib/HID/baselib.inc.z80"
	include "asmlib/HID/basestructs.inc.z80"
	include "asmlib/HID/joylib.inc.z80"

