;REPLAYER:	include "sound\PT3-ROM.ASM"
    include "sound\pt3ROM.ASM"
    include "sound\ayfx-ROM.ASM"


music01:      incbin "sound\gameMusic1.pt3.mlz"
    ;block 100,0
music02:      incbin "sound\gameMusic2.pt3.mlz"
;    block 100,0
music03:      incbin "sound\gameMusic4.pt3.mlz"
;    block 100,0
music04:      incbin "sound\gameMusic3.pt3.mlz"
;    block 100,0
music05:      incbin "sound\gameMusic5.pt3.mlz"
    ;block 100,0
music06:      incbin "sound\gameMusic6.pt3.mlz"
;    block 100,0
musicEnding:      incbin "sound\ending.pt3.mlz"
;    block 100,0
menuMusic:      incbin "sound\menu.pt3.mlz"
;    block 100,0

musgameover:	incbin "sound\miedPrelude.pt3.mlz"

nullMusic: incbin "sound\nullMusic.pt3",99




music:  dw music01,music02,music03,music04,music05,music06
.end:

SFXDATA:	incbin "sound\sfx.afb"    

initAYFX:
	ld	hl,SFXDATA
	jp	ayFX_SETUP

initLevelMusic:
        ld	a,(map+OBJMAP.musTrack)
	cp	#FF		; Ending song?
	ld	hl,musicEnding
	jr	z,initMusic	; Yes, skip 
	cp	(music.end-music)/2	; >last music?
	jr	c,5F			; Yes, clip to the max
	ld	a,(music.end-music)/2
5:	dec	a
	jp	p,10F		; Skip if random wasn't requested
	; Random song
	call	xrnd16
	ld	a,h
	add	l
	ld	e,a
	ld	c,43
	call	Div8
10:	add a,a : ld c,a : ld b,0
        ld hl,music 
        add hl,bc
        ld a,(hl): inc hl : ld h,(hl) :ld l,a
initMusic:
	push	hl
	call	muteMusic
	di
	; Clear the music buffer
	ld	hl,musicBuffer
	ld	bc,((((LOW (MUSBUFFERSIZE-1))+1)<<8))+(HIGH (MUSBUFFERSIZE-1))+1
	xor	a
20:	ld	(hl),a
	inc	hl
	djnz	20B
	dec	c
	jr	nz,20B
	pop	hl
	ld	de,musicBuffer	: call	DEC40

        ld	hl,musicBuffer
	call	PT3_INIT			; Inits PT3 player
        ld a,(PT3_SETUP) : res 0,a : ld (PT3_SETUP),a		
        ei
	ld	b,3
	jp	haltDelay

muteMusic:
        call	waitVBL
        di        
        call	PT3_ROUT;write to AY from AY_REGS
        ld		hl,nullMusic-99			; hl <- initial address of module - 99        
		call	PT3_INIT			; Inits PT3 player                
		call	PT3_PLAY;play to AY_REGS
        call ayFX_PLAY
        ;ld a,(PT3_SETUP) : res 0,a : ld (PT3_SETUP),a		
        ;call PT3_PLAY
        ;call PT3_MUTE
        ei
	ld	b,10
	call	haltDelay
	jp	GICINI

AFXPLAY3:
    di : ld c,7 : call ayFX_INIT : ei
    ret

stopPlayer:
	ld	a,#ff
	ld	(mpbusy),a
	ret

startPlayer:
	ld	a,0		; Preserve flags	
	ld	(mpbusy),a
	ret


playMineSound:
	ld	a,11
	jp	AFXPLAY3

playBumSound:
	ld	a,12
	jp	AFXPLAY3

playMostSound:
    ld a,(mostSoundCount) : inc a : and 1 : ld (mostSoundCount),a
    add 9
    jp AFXPLAY3

playCollectSound2:
    	ld	a,7
 	jp	AFXPLAY3

playCollectSound:
	ld	a,8
	jp	AFXPLAY3


playPutBlockSound:
    ld a,5 : jp AFXPLAY3

playHideBlockSound:
    ld a,6 : jp AFXPLAY3

checkStartFall:
    ld a,(hero.prevState)
    cp HERO_FALL
    ret z
    ld a,2 : jp AFXPLAY3

checkLand:
    ld a,(hero.state)
    cp HERO_FALL
    ret z
    ld a,1 : jp AFXPLAY3

doHeroSounds:
    //start fall
    ld a,(hero.state)
    cp HERO_FALL
    call z,checkStartFall

    //land
    ld a,(hero.prevState)
    cp HERO_FALL
    call z,checkLand

    ld a,(hero.state)
    cp HERO_IDLE
    ret z

    cp HERO_MOVE_UP
    jr z,ladderSound
    cp HERO_MOVE_DOWN
    jr z,ladderSound

    cp HERO_MOVE_LEFT
    jr z,walkSound
    cp HERO_MOVE_RIGHT
    jr z,walkSound
    cp HERO_FALL
    jr z,fallSound
    ret	

fallSound:
    ld a,(hero.moveCounter)
    cp 3
    ret nz
    ld a,0 ;: jp AFXPLAY3
	ld	c,15
	jp	ayFX_INIT


ladderSound:
    ld a,(hero.moveCounter)
    cp 7
    ret nz
    ld a,3 ;: jp AFXPLAY3
	ld	c,15
	jp	ayFX_INIT


walkSound:
    ld a,(hero.moveCounter)
    cp 7
    ret nz
    ld a,(walkSoundCount)
    inc a : and 1
    ld (walkSoundCount),a
    add 3
    ;ld a,4 : call AFXPLAY
;    jp AFXPLAY3
	ld	c,15
	jp	ayFX_INIT

teleportSound:
	ld	a,19
	ld	c,6
	jp	ayFX_INIT

enemyDeadSound:
	ld	a,18
	jp	AFXPLAY3

pauseSound:
	call	muteMusic
	ld	a,15		; Pause sound
	ld	c,0
	jp	ayFX_INIT

