; Contains all VDP related routines

FONTSIZE=768

TILEBMPSIZE	equ	tilesPixles.end-tilesPixles
SPRBMPSIZE	equ	endSprites-spritesPixels

 STRUCT VDPSPR
yPos		db
xPos		db
pattern		db
color		db
 ENDS



myDISSCR:	; Disable screen without tearing
	call	waitVBL
	jp	DISSCR

myENASCR:	; Enable screen without tearing
	call	waitVBL
	jp	ENASCR

clearAllSprites:
	ld	bc,(MAXENEMIES+1)*256+ENEMY_Y_DISABLE
	ld	de,VDPSPR
	ld	hl,spritesTable
30:	ld	(hl),c
	add	hl,de
	djnz	30B

	;Init hero color 
	ld	a,15 :	ld	(spritesTable+VDPSPR.color),a

;	jp	doSprites

;tmp set sprites to screen

doSprites:
 IFDEF PROFILER
	ld	bc,#0407	; SAT write = Green
	call	WRTVDP
 ENDIF

;	ld	a,(satBackBuf)
;	xor	7		; Flip SAT page
;	ld	d,a
;	ex	af,af'
;	ld hl,spritesTable : ld e,0 : ld bc,VDPSPR*(MAXENEMIES+1)
	ld hl,spritesTable : ld de,#1B00 : ld bc,VDPSPR*(MAXENEMIES+1)
;	ex	af,af'
;	ld	(satBackBuf),a
;flipSAT:		; MSX1 can't change registers on interrupt, sadly
;	add	a
;	ld	b,a
;	ld	c,5
 IFNDEF PROFILER
;	jp	WRTVDP
	jp	LDIRVM
 ELSE
;	call	WRTVDP
	call	LDIRVM
	ld	bc,#0207	; Game Loop = Green
	jp	WRTVDP
 ENDIF

	; Set the SAT page
fillTiles01:
	ld hl,tilesColors : ld de,8192 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesColors : ld de,8192+2048 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesColors : ld de,8192+4096 : ld bc,TILEBMPSIZE : jp LDIRVM

fillTiles02:
	ld hl,tilesColors2 : ld de,8192 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesColors2 : ld de,8192+2048 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesColors2 : ld de,8192+4096 : ld bc,TILEBMPSIZE : jp LDIRVM
fillTiles03:
	ld hl,tilesColors3 : ld de,8192 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesColors3 : ld de,8192+2048 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesColors3 : ld de,8192+4096 : ld bc,TILEBMPSIZE : jp LDIRVM

fillFont:
	ld	de,2048-FONTSIZE :	call	.copyFntBmp
	ld	de,8192+2048-FONTSIZE :	call	.copyFntClr
	ld	de,6144-FONTSIZE :	call	.copyFntBmp
	ld	de,8192+6144-FONTSIZE : call	.copyFntClr
.center:
	ld	de,4096-FONTSIZE :	call	.copyFntBmp
	ld	de,8192+4096-FONTSIZE :	;jp	.copyFntClr

.copyFntClr:	; Input: de=Dest VRAM address
	ex	de,hl			; e=Number of chars
	call	SETWRT
	ld	a,(VDP.DW)
	ld	c,a			; c=VDP.DW
	ld	e,FONTSIZE/8
20:	ld	b,8			; b=8 bytes/char
	ld	hl,fontColors
30:	outi
	jp	nz,30B
	dec	e
	jr	nz,20B
	ret

.copyFntBmp:	; Input: de=Dest VRAM address
	push	de
	ld	hl,font
	ld	de,musicBuffer
	call	DEC40
	ld	hl,musicBuffer
	pop	de
	ld	bc,FONTSIZE
	jp	LDIRVM

fillVDP:
	call fillFont	
    ;(?)need to switch for more economy mode without thirds
    ;patterns
	ld hl,tilesPixles : ld de,0000 : ld bc,TILEBMPSIZE : call LDIRVM
	ld hl,tilesPixles : ld de,2048 : ld bc,TILEBMPSIZE : call LDIRVM	
	ld hl,tilesPixles : ld de,4096 : ld bc,TILEBMPSIZE : call LDIRVM	

    ;colors
	call	fillTiles01
	ld hl,spritesPixels : ld de,$3800 : ld bc,SPRBMPSIZE: jp LDIRVM

;fills name table with specific tile
; A - tile
fillTile:    
    push af   
    ld a,e     
    ld l,d : ld h,0 
    add hl,hl : add hl,hl : add hl,hl : add hl,hl : add hl,hl
    ld d,0 : add hl,de
    ld de,$1800 
    add hl,de ;: ex de,hl
    ;call setVADDRHL
	pop af    
	jp WRTVRM ;to hl writes a

;de - real coords
; a - tile to fill
fillTileXY:    
    push af   
	
	ld a,e : add 4
	rra : rra : rra ;/8
	and 31
	ld e,a	

	;get y
	ld a,d : add 6
	rra : rra : rra ;/8
	and 31
	ld d,a

	;
    ld a,e     
    ld l,d : ld h,0 
    add hl,hl : add hl,hl : add hl,hl : add hl,hl : add hl,hl
    ld d,0 : add hl,de
    ld de,$1800 
    add hl,de ;: ex de,hl
    ;call setVADDRHL
	pop af    
	jp WRTVRM ;to hl writes a

;fill all screen with one tile
clearScreen:
	ld hl,$1800 : ld bc,768 : ld a,0 : jp FILVRM

animateFire:
	;animate delay
	ld a,(fireDelay) : inc a : and 3 : ld (fireDelay),a
	or a: ret nz
 	;process frames
	ld a,(fireFrame)
	inc a : and 3 : ld (fireFrame),a
	ld hl,fireTile: add a,a : add a,a : add a,a : ld c,a : ld b,0
	add hl,bc
	;write hl to vram at fire tile position
	push hl : 	ld de,3*8 : ld bc,8 : call LDIRVM : pop hl	
	push hl : 	ld de,3*8+2048 : ld bc,8 : call LDIRVM : pop hl	
	ld de,3*8+4096 : ld bc,8 : jp LDIRVM 

animateGold:
	;animate delay
	ld a,(goldDelay) : inc a : and 3 : ld (goldDelay),a
	or a: ret nz
 	;process frames
	ld a,(fireFrame);one frmae count
	ld hl,goldTile: add a,a : add a,a : add a,a : ld c,a : ld b,0
	add hl,bc
	;write hl to vram at fire tile position
	push hl : 	ld de,1*8 : ld bc,8 : call LDIRVM : pop hl	
	push hl : 	ld de,1*8+2048 : ld bc,8 : call LDIRVM : pop hl	
	ld de,1*8+4096 : ld bc,8 : jp LDIRVM 


;-------------------------------------------------------------------------
; Enemy Sprite routines

calcEnemiesSprites:
	ld	ix,enemiesList
	ld	hl,(spritePtr)
;	ld	bc,VDPSPR
;	add	hl,bc
;	ld	de,spritesTable+VDPSPR+VDPSPR*MAXENEMIES
;	rst	DCOMPR
;	jr	c,20F
;	ld	hl,spritesTable+VDPSPR
20:	push	hl
	pop	iy
 IFDEF SHOWCLRENEMY
	ld	bc,MAXENEMIES*256+3
 ELSE
	ld	b,MAXENEMIES
 ENDIF
.loop1:
    ;skip if in limbo or disabled
	ld	a,(ix+OBJENEMY.yPos);get state
	cp	ENEMY_Y_LIMBO	; Is he disabled in limbo?
	jr	c,.doOneSprite		; Yes, skip
	ld	(iy+VDPSPR.yPos),ENEMY_Y_DISABLE
	jr	200F 

.doOneSprite:
	push	bc
	;get coords and put to start
	ld	c,(ix+OBJENEMY.yPos)
	ld	b,(ix+OBJENEMY.xPos)
	ld	(iy+VDPSPR.yPos),c
	ld	(iy+VDPSPR.xPos),b
	
	;apply a frame by move count
	ld	a,(ix+OBJENEMY.sprFrame)
	ld	(iy+VDPSPR.pattern),a

	;calc basic animations   
	;delay 
	ld	a,(ix+OBJENEMY.sprAnimDelay)
	inc	a :	and 3
	ld	(ix+OBJENEMY.sprAnimDelay),a
	or	a
	jr	nz,1f
	ld	a,(ix+OBJENEMY.animCounter);get basic counter
	inc	a :	and 1
	ld	(ix+OBJENEMY.animCounter),a    

1:	; Select the enemy color based on its state
	pop	bc
	ld	a,(ix+OBJENEMY.moveCounter)        
	cp	32		; >8 movecount?
	jr	c,20f		; No, skip
	; Spawn: blink sprite
	ld	(iy+VDPSPR.color),ENEMY_CLRSPAWN    
	bit	0,(ix+OBJENEMY.moveCounter)        
	jr	nz,200f
	ld	(iy+VDPSPR.yPos),209	; Take off of screen
	jr	200f
20:	ld	a,(ix+OBJENEMY.deathTimer)
	or	a
	ld	a,ENEMY_CLRDEAD
	jr	nz,40F
 IFDEF SHOWENEMYMODE
	ld	e,c
	dec	e
	ld	a,(ix+OBJENEMY.mode)
	cp	MODE_ANGRY
;	ld	a,ENEMY_CLRANGRY
	ld	a,e
	jr	z,40F
 ENDIF
 IFDEF SHOWCLRENEMY
	ld	a,c
 ELSE
	ld	a,ENEMY_COLOR
 ENDIF
40:	ld	(iy+VDPSPR.color),a    

200:	; Next sprite
 IFDEF SHOWCLRENEMY
	ld	a,c
	add	2
	cp	14
	jr	c,220F
	ld	a,3
220:	ld	c,a
 ENDIF
	ld	de,OBJENEMY
	add	ix,de
	call	.nextVdpSpr
250:	djnz	.loop1
	call	.nextVdpSpr
	ld	(spritePtr),iy
	ret

.nextVdpSpr:
	ld	de,VDPSPR*7
	add	iy,de
	ld	de,spritesTable+VDPSPR+VDPSPR*MAXENEMIES
	ld	a,yh
	cp	d
	jr	c,260F
	ld	a,yl
	cp	e
	jr	c,260F
	ld	de,-(VDPSPR*MAXENEMIES)
	add	iy,de
260:	ret


;-------------------------------------------------------------------------
; Hero Sprite routines

setHeroColor:	; Input: a=Hero color
	ld	(spritesTable+VDPSPR.color),a
	ld	hl,(GRPATR)
	inc	hl
	inc	hl
	inc	hl
	jp	WRTVRM


;calculate hero sprite addr by hero state
calcHeroSprite:
    ;apply hero position to sprite0
    ld a,(hero.xPos) : ld (spritesTable+VDPSPR.xPos),a
    ld a,(hero.yPos) : ld (spritesTable+VDPSPR.yPos),a

	ld a,(hero.state)            
	or a			: jr z,calcHeroSpriteIdle
	cp HERO_FALL		: jr z,calcHeroSpriteFall    
	cp HERO_MOVE_UP 	: jr z,calcHeroSpriteLadder
	cp HERO_MOVE_DOWN 	: jr z,calcHeroSpriteLadder
	
	;ok standart moving
calcHeroSpriteMoving:
    ;walk animation is 8-15 - right and 16-23 - left
    ld c,8
    CP HERO_MOVE_LEFT
    jr nz,1f
    ld c,0
1:
    ;ok - frame is movecount
    ld a,(hero.moveCounter)
    add c
    add 8

    ;every frame is from 4 cells
    add a,a : add a,a
    ld (spritesTable+VDPSPR.pattern),a
	ret


calcHeroSpriteIdle:

	ld de,(hero.xPos)	
	call getTile
	cp TILE_LADDER
	ret z

    ;get idle animation calculated in basic animation and put to sprite 0 - hero sprite
	;idle animation is 0,1 - right and 2,3 - left
	ld	a,(hero.faceDir)
	dec	a	: add	a	: add	a	: add	a
	ld	c,a
	ld	a,(hero.animCounter)      
	;every sprite frame is from 4 cells
	add	a	: add	a	; c=baseAnimFrame
	add	c
	ld	(spritesTable+VDPSPR.pattern),a
	ret

calcHeroSpriteFall:		
    ld a,(hero.animCounter)      
    ;fall animation is 6,7
    add 6
    ;every frame is from 4 cells
    add a,a : add a,a
	ld (spritesTable+VDPSPR.pattern),a
	ret


calcHeroSpriteLadder:
    ld a,(hero.animCounter)      
    ;ladder animation is 4,5
    add 4
    ;every frame is from 4 cells
    add a,a : add a,a
	ld (spritesTable+VDPSPR.pattern),a
	ret


